package controles;

import java.awt.Toolkit;
import javax.swing.ImageIcon;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class ImageManager 
{
	// IMAGES
	private ImageIcon[] joueur;
	private ImageIcon[] ennemis;
	private ImageIcon[] tirs;
	private ImageIcon[] bonus;
	
	private ImageIcon[] infos;
	
	private ImageIcon   balle;
	private ImageIcon   tableauJeu;
	private ImageIcon   niveau;
	
	private static ImageManager img = new ImageManager();
	
	/**
	 * Permet de precharger les images
	 */
	private ImageManager()
	{
		// TABLEAU DE JEU
		tableauJeu 		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Controles/jeu.png"));
		
		// BALLE
		balle 			= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Balle/balle.png"));
		
		// JOUEUR
		joueur 			= new ImageIcon[5];
		joueur[0] 		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Joueur/gauche.png"));
		joueur[1] 		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Joueur/centre.png"));
		joueur[2] 		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Joueur/droite.png"));   
		joueur[3] 		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Joueur/angleDroit.png"));
		joueur[4] 		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Joueur/angleGauche.png"));   
		
		// ENNEMIS
		ennemis			= new ImageIcon[9];
		for( int i=0; i<ennemis.length; i++)
			ennemis[i] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Ennemis/"+(i+1)+".png"));
		
		// TIRS
		
		tirs			= new ImageIcon[2];
		tirs[0]			= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Tirs/tirJoueur.png")); 
		tirs[1]			= tirs[0]; 
		
		// BONUS
		
		bonus			= new ImageIcon[6];
		bonus[0]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Bonus/1.png")); 
		bonus[1]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Bonus/2.png")); 
		bonus[2]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Bonus/3.png")); 
		bonus[3]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Bonus/4.png")); 
		bonus[4]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Bonus/5.png")); 
		bonus[5]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Bonus/6.png")); 
		
		// INFOS
		infos			= new ImageIcon[6];
		infos[0]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Controles/intro.png")); 
		infos[1]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Controles/niveauTermine.png")); 
		infos[2]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Controles/gameOver.png")); 
		infos[3]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Controles/vide.png")); 
		infos[4]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Controles/finJeu.png")); 
		infos[5]		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Controles/demandeNom.png")); 
	}
	
	
	// GETTERS
	
	/**
	 * Obtenir le gestionnaire d'images
	 * @return
	 */
	public static ImageManager getImagemanager()
	{
		return img;
	}
	
	/**
	 * Obtenir une image du joueur
	 * @param i numero de l'image
	 * @return Image du joueur
	 */
	public ImageIcon getImageJoueur( int i )
	{
		return joueur[i];
	}
	
	/**
	 * Obtenir image d'un ennemi
	 * @param i num�ro de l'ennemi
	 * @return Image de l'ennemi
	 */
	public ImageIcon getImageEnnemi( int i )
	{
		return ennemis[i];
	}
	
	
	/**
	 * Obtenir l'image du tir
	 * @param i num�ro du tir
	 * @return image du tir
	 */
	public ImageIcon getImageTir( int i )
	{
		return tirs[i];
	}
	
	
	/**
	 * Obtenir l'image du bonus
	 * @param i num�ro du bonus
	 * @return image du bonus
	 */
	public ImageIcon getImageBonus( int i )
	{
		return bonus[i];
	}
	
	
	/**
	 * Obtenir l'image de l'info
	 * @param i num�ro de l'info
	 * @return image
	 */
	public ImageIcon getImageInfos( int i )
	{
		return infos[i];
	}
	
	
	/**
	 * Obtenir l'image de la balle
	 * @return image de la balle
	 */
	public ImageIcon getImageBalle()
	{
		return balle;
	}
	
	
	/**
	 * Obtenir l'image du tableau de jeu
	 * @return image du tableau de jeu
	 */
	public ImageIcon getImageTableauJeu()
	{
		return tableauJeu;
	}
	
	
	/**
	 * Obtenir l'image de fond du niveau
	 * @return image de fond du niveau
	 */
	public ImageIcon getImageNiveau()
	{
		return niveau;
	}
	
	
	
	// SETTERS
	
	/**
	 * modifier l'image de fond du niveau
	 * @param chemin lieu ou se trouve l'image
	 */
	public void setImageNiveau( String chemin )
	{
		niveau = new ImageIcon(Toolkit.getDefaultToolkit().getImage(chemin));
	}	
}