package controles;

import java.io.FileInputStream;
import java.util.HashMap;
import java.util.Properties;

public class OptionsManager 
{
	private static OptionsManager om = new OptionsManager();

	private HashMap<String, Integer> options;
	
	private OptionsManager()
	{
		options = new HashMap<String, Integer>();
		
		Properties lecteur = new Properties();
		FileInputStream fichier;
		
		try
		{
			fichier = new FileInputStream("Data/options.sb");
			lecteur.load(fichier);
			fichier.close();
			
			options.put( "fullScreen" 	, Integer.parseInt( lecteur.getProperty("fullScreen") ));	
			options.put( "nbContinues" 	, Integer.parseInt( lecteur.getProperty("nombreContinues") ));	
			options.put( "width" 		, Integer.parseInt( lecteur.getProperty("resolutionWitdh") ));	
			options.put( "height" 		, Integer.parseInt( lecteur.getProperty("resolutionHeight") ));	
		}
		catch( Exception e){ options.put( "fullScreen" , 0 );}		
	}
	
	public static OptionsManager getInstance()
	{
		return om;
	}
	
	public int get( String op )
	{
		if( options.get(op) != null)
			return options.get(op);
		
		return -1;
	}
	
	public void set( String op, int value )
	{
		options.put(op,value);
	}
}
