package controles;

import java.io.File;

import son.MultiSon;
import son.Son;


public class SonManager 
{
	private static SonManager son = new SonManager();
	
	private Son 		musiqueMenu;
	private Son 		musiqueJeu;
	private Son			musiqueIntro;
	private Son			musiqueFinNiveau;
	private Son			musiqueGameOver;
	private Son			musiqueFinJeu;
	
	private MultiSon 	rebond;
	private MultiSon 	beepMenu;
	private MultiSon 	beepMenuValider;
	private MultiSon	mortEnnemi;
	private MultiSon	toucheEnnemi;
	private MultiSon	toucheJoueur;
	private MultiSon	mortBalle;
	private MultiSon	tirJoueur;
	private MultiSon	bonus;
	private MultiSon	changerSensLancementBalle;
	
	private SonManager()
	{

		try
		{
			// Ok
			beepMenu 					= new MultiSon( new File( "Sons/beep.wav" 						), 5 );
			beepMenuValider 			= new MultiSon( new File( "Sons/beep2.wav" 						), 2 );
			rebond 						= new MultiSon( new File( "Sons/rebond.wav" 					), 4 );
			mortEnnemi 					= new MultiSon( new File( "Sons/mortEnnemi.wav" 				), 4 );
			toucheEnnemi				= new MultiSon( new File( "Sons/toucheEnnemi.wav" 				), 4 );
			toucheJoueur				= new MultiSon( new File( "Sons/mortBalle.wav" 					), 2 );
			mortBalle					= new MultiSon( new File( "Sons/mortBalle.wav" 					), 2 );			
			tirJoueur					= new MultiSon( new File( "Sons/tirJoueur.wav" 					), 2 );			
			bonus						= new MultiSon( new File( "Sons/bonus.wav" 						), 4 );				
			musiqueMenu					= new Son( 		new File( "Musiques/menu.wav" 					)	 );			
			musiqueIntro				= new Son( 		new File( "Musiques/intro.wav" 					)	 );			
			musiqueJeu 					= new Son( 		new File( "Musiques/jeu.wav"					)	 );
			
			// Bug Sous Linux
			musiqueGameOver				= new Son( 		new File( "Musiques/gameOver.wav" 				)	 );		
			musiqueFinNiveau			= new Son( 		new File( "Musiques/finNiveau.wav" 				)	 );			
			musiqueFinJeu				= new Son( 		new File( "Musiques/finJeu.wav" 				)	 );	
			changerSensLancementBalle 	= new MultiSon( new File( "Sons/changerSensLancementBalle.wav"	), 4 );
		}
		catch( Exception e)
		{
			System.err.println( e.getMessage() );
		}
	}
	
	public static SonManager getSonManager()
	{
		return son;
	}
	
	
	// SONS ...
	
	public void jouerRebond()
	{
		if( rebond != null )
		rebond.jouer();
	}
	
	public void jouerBeepMenu()
	{
		if( beepMenu != null )
			beepMenu.jouer();
	}
	
	public void jouerBeepMenuValider()
	{
		if( beepMenuValider != null )
			beepMenuValider.jouer();
	}
	
	public void jouerToucheEnnemi()
	{
		if( toucheEnnemi != null )
			toucheEnnemi.jouer();
	}
	
	public void jouerToucheJoueur()
	{
		if( toucheJoueur != null )
			toucheJoueur.jouer();
	}
	
	public void jouerTirJoueur()
	{
		if( tirJoueur != null )
			tirJoueur.jouer();
	}
	
	public void jouerChangerSensLancementBalle()
	{
		if( changerSensLancementBalle != null )
			changerSensLancementBalle.jouer();
	}
	
	public void jouerMortEnnemi()
	{
		if( mortEnnemi != null )
			mortEnnemi.jouer();
	}
	
	public void jouerMortBalle()
	{
		if( mortBalle != null )
			mortBalle.jouer();
	}
	
	public void jouerBonus()
	{
		if( bonus != null )
			bonus.jouer();
	}
	
	
	// MUSIQUES
	
	public void jouerMusiqueFinJeu()
	{
		if( musiqueFinJeu != null )
			musiqueFinJeu.jouer();
	}
	
	
	
	public void jouerMusiqueJeu()
	{
		if( musiqueJeu != null )
			musiqueJeu.boucle();
	}
	
	public void stopMusiqueJeu()
	{
		if( musiqueJeu != null )
			musiqueJeu.stop();
	}
	
	public void pauseMusiqueJeu()
	{
		if( musiqueJeu != null )
			musiqueJeu.pause();
	}
	
	public void repriseMusiqueJeu()
	{
		if( musiqueJeu != null )
			musiqueJeu.reprise();
	}
	
	
	public void jouerMusiqueMenu()
	{
		if( musiqueMenu != null )
			musiqueMenu.boucle();
	}
	
	public void stopMusiqueMenu()
	{
		if( musiqueMenu != null )
			musiqueMenu.stop();
	}
	
	public void pauseMusiqueMenu()
	{
		if( musiqueMenu != null )
			musiqueMenu.pause();
	}
	
	
	public void jouerMusiqueIntro()
	{
		if( musiqueIntro != null )
			musiqueIntro.jouer();
	}
	
	public void jouerMusiqueFinNiveau()
	{
		if( musiqueFinNiveau != null )
			musiqueFinNiveau.jouer();
	}
	
	public void jouerMusiqueGameOver()
	{
		if( musiqueGameOver != null )
			musiqueGameOver.jouer();
	}
}
