package editeur;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Properties;
import javax.swing.*;

/**
 * 
 * @author Simon Mahieux et Jerome Baudoux
 *
 */
public class Editeur extends javax.swing.JFrame 
{

	private static final long serialVersionUID = 1L;
	
	
	
	// VARIABLES GRAPHIQUES
    private javax.swing.JButton jBScreen;
    private javax.swing.JLabel jLInfosBonus;
    private javax.swing.JLabel jLInfosBrique;
    private javax.swing.JLabel jLInfosMode;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuBar jMenuBar2;
    private javax.swing.JMenuBar jMenuBar3;
    private javax.swing.JMenuBar jMenuBar4;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JTextField jTScreen;
    private javax.swing.JTabbedPane jTabbPane;
    private javax.swing.JMenu menuFichier;
    private javax.swing.JMenu menuFichier1;
    private javax.swing.JMenu menuFichier2;
    private javax.swing.JMenu menuFichier3;
    private javax.swing.JMenuItem menuFichierQuitter;
    private javax.swing.JMenuItem menuFichierQuitter1;
    private javax.swing.JMenuItem menuFichierQuitter2;
    private javax.swing.JMenuItem menuFichierQuitter3;
    private javax.swing.JMenu menuNiveau;
    private javax.swing.JMenu menuNiveau1;
    private javax.swing.JMenu menuNiveau2;
    private javax.swing.JMenu menuNiveau3;
    private javax.swing.JMenuItem menuNiveauCharger;
    private javax.swing.JMenuItem menuNiveauCharger1;
    private javax.swing.JMenuItem menuNiveauCharger2;
    private javax.swing.JMenuItem menuNiveauCharger3;
    private javax.swing.JMenuItem menuNiveauEnregistrer;
    private javax.swing.JMenuItem menuNiveauEnregistrer1;
    private javax.swing.JMenuItem menuNiveauEnregistrer2;
    private javax.swing.JMenuItem menuNiveauEnregistrer3;
    private javax.swing.JMenuItem menuNiveauEnregistrerSS;
    private javax.swing.JMenuItem menuNiveauEnregistrerSS1;
    private javax.swing.JMenuItem menuNiveauEnregistrerSS2;
    private javax.swing.JMenuItem menuNiveauEnregistrerSS3;
    private javax.swing.JMenuItem menuNiveauTester;
    private javax.swing.JMenuItem menuNiveauTester1;
    private javax.swing.JMenuItem menuNiveauTester2;
    private javax.swing.JMenuItem menuNiveauTester3;
    private javax.swing.JMenu menuOptions;
    private javax.swing.JMenu menuOptions1;
    private javax.swing.JMenu menuOptions2;
    private javax.swing.JMenu menuOptions3;
    private javax.swing.JMenuItem menuOptionsModeCont;
    private javax.swing.JMenuItem menuOptionsModeCont1;
    private javax.swing.JMenuItem menuOptionsModeCont2;
    private javax.swing.JMenuItem menuOptionsModeCont3;
    private javax.swing.JPanel panelGrille;
	
	
	// VARIABLES EDITEUR
	

	// La grille de JLabel
    private JLayeredPane grilleIHM[][];
    // Tableau des briques
    private ImageIcon lstBriques[];
    // Tableau des bonus
    private ImageIcon lstBonus[];
    // Nombres de briques
    static int nbBriques = 10;
    // Nombres de bonus
    static int nbBonus = 7;
    private Boolean colorise;
    private Niveau niv;
    // Brique selectionne
    int briqueSel;    
    // Bonus selectionne
    int bonusSel;
    
    /**
     * Costructeur d'un editeur
     */
    public Editeur()
    {
        initComponents();
        try
        {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
            SwingUtilities.updateComponentTreeUI(this);
            this.setIconImage( new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Logo/16.png") ).getImage() );
            setLocationRelativeTo( getParent() );
        }
        catch (Exception e) {}

        // Chargement des images
        initImgBriques();
        initImgBonus();
        
        colorise = false;
        jLInfosMode.setText("Off");
        jLInfosBrique.setIcon(lstBriques[0]);
        
        // Affiche la grille
        initGrille();
        // Affiche les briques
        initBriques();
        // Affiche les bonus
        initBonus();
    }

    /**
     * Initialse les images briques
     */
    public void initImgBriques()
    {
        // Permet de ne charger qu'une seule fois les imgs :)
        lstBriques = new ImageIcon[11];
        for(int i=0;i<11;i++)
        {
            lstBriques[i]=new ImageIcon( "Images/Editeur/Ennemis/"+i+".png");
        }
    }
    
    /**
     * Initialise les images Bonus
     */
    public void initImgBonus()
    {
        // Permet de ne charger qu'une seule fois les imgs :)
        lstBonus = new ImageIcon[7];
        for(int i=0;i<7;i++)
        {
            lstBonus[i]=new ImageIcon( "Images/Editeur/Bonus/"+i+".png");
        }
    }

    /**
     * Initialise les briques
     */
    public void initBriques()
    {
        JPanel panelBriques = new JPanel();

        // (rows, cols, hgap, vgap)
        // panelBriques.setLayout(new GridLayout(MAX_ELEMENT,1,0,0));
        
        briqueSel=0;
        
        // Affiche la grille
        for(int i=0;i<nbBriques;i++)
        {
            final int id = i;
            JButton tmp = new JButton(lstBriques[i]);
            tmp.setSize(lstBriques[i].getIconWidth(), lstBriques[i].getIconHeight());
            // Ajoute l'ecouteur
            tmp.addActionListener(new ActionListener() 
            {
                public void actionPerformed(ActionEvent ev) 
                {
                    selectionneBrique(id);
                }
            });
            tmp.setToolTipText(getDescrBrique(i));
            panelBriques.add(tmp);
        }
        jTabbPane.addTab("Briques", panelBriques);
    }

    /**
     * Initialise les bonus
     */
    public void initBonus()
    {
        JPanel panelBonus = new JPanel();
        //panelBonus.setLayout(new GridLayout(MAX_ELEMENT,1,0,0));     
        
        bonusSel=0;
        
        // Affiche la grille
        for(int i=0;i<nbBonus;i++)
        {
            final int id = i;
            JButton tmp = new JButton(lstBonus[i]);
            tmp.setSize(lstBonus[i].getIconWidth(), lstBonus[i].getIconHeight());
            
            // Ajoute l'ecouteur
            tmp.addActionListener(new ActionListener() 
            {
                public void actionPerformed(ActionEvent ev) 
                {
                    selectionneBonus(id);
                }
            });
            tmp.setToolTipText(getDescrBonus(i));
            panelBonus.add(tmp);
        }
        jTabbPane.addTab("Bonus", panelBonus);
    }
    
    
    /**
     * Renvoie la description d'une brique
     * @param i numero brique
     * @return description
     */ 
    public String getDescrBrique(int i)
    {
        String res = new String("Pas de description");
        try
        {
            Properties prop = new Properties();
            FileInputStream in = new FileInputStream("Data/briques.sb");
            prop.load(in);
            in.close();
            res = prop.getProperty(new String("Brique_"+new Integer(i).toString()));
        }
        catch (Exception e)
        {
            System.err.println(e.getMessage());
        }
        return res;
    }
    
    /**
     * Renvoie la description d'un bonus
     * @param i numero bonus
     * @return description
     */
    public String getDescrBonus(int i)
    {
        String res = new String("Pas de description");
        try
        {
            Properties prop = new Properties();
            FileInputStream in = new FileInputStream("Data/bonus.sb");
            prop.load(in);
            in.close();
            res = prop.getProperty(new String("Bonus_"+new Integer(i).toString()));
        }
        catch (Exception e)
        {
            System.err.println(e.getMessage());
        }
        return res;
    }

    /**
     * Initialise grille
     */
    public void initGrille()
    {
        // Partie Grille
        niv = new Niveau();
        
        // Partie Interface
        grilleIHM = new JLayeredPane[niv.getNbLig()][niv.getNbCol()];
        panelGrille.setLayout(new GridLayout(niv.getNbLig(),niv.getNbCol(),0,0));
        
        // Affiche la grille
        for(int nblig=0;nblig<niv.getNbLig();nblig++)
        {
            // Oblige d'etre en final pour pouvoir l'utiliser dans mouseClicked
            final int msligne = nblig;
            
            for(int nbcol=0;nbcol<niv.getNbCol();nbcol++)
            {
                // Oblige d'etre en final pour pouvoir l'utiliser dans mouseClicked
                final int mscolonne = nbcol;

                JLabel LabelBrique  = new JLabel(lstBriques[0]);
                LabelBrique.setBounds(0,0,lstBriques[0].getIconWidth(),lstBriques[0].getIconHeight());
                
                JLabel LabelBonus = new JLabel(lstBonus[0]);
                LabelBonus.setBounds(0,0,lstBonus[0].getIconWidth(),lstBonus[0].getIconHeight());

                JLayeredPane panne = new JLayeredPane();
                panne.setPreferredSize(new Dimension(lstBriques[0].getIconWidth(), lstBriques[0].getIconHeight()));
                panne.add(LabelBrique, new Integer(1));
                panne.add(LabelBonus, new Integer(2));

                panne.addMouseListener(new MouseAdapter()
                {
                    public void mouseEntered(MouseEvent e)
                    {
                        if(colorise)
                        {
                            remplaceBrique(msligne,mscolonne);
                        }
                    }

                    public void mouseClicked(MouseEvent evt)
                    {
                        if(evt.getButton()==MouseEvent.BUTTON1) // Clique gauche
                        {
                            // Regarde quel onglet est ouvert
                            // Si c'est l'onglet des briques
                            if(jTabbPane.getSelectedIndex()==0) // Onglet brique
                            {
                                remplaceBrique(msligne,mscolonne);
                            }
                            else // Onglet Bonus
                            {
                                remplaceBonus(msligne,mscolonne);
                            }
                                
                        }
                        else if(evt.getButton()==MouseEvent.BUTTON3) // Clique droit
                        {
                            if(jTabbPane.getSelectedIndex()==0) // Onglet brique
                            {
                                // Supprime bonus et brique
                                supprimeBrique(msligne,mscolonne);
                            }
                            else
                            {
                                 // Supprime bonus
                                 supprimeBonus(msligne,mscolonne);
                            }
                        }
                        else if(evt.getButton() == MouseEvent.BUTTON2) // Clique molette
                        {
                            remplaceBrique(msligne,mscolonne);
                            changeMode();
                        }
                    }
                });

                grilleIHM[nblig][nbcol]=panne;
                panelGrille.add(panne);
                jTScreen.setText(niv.getChemin());
            }
        }
    }
    
    /**
     * Selectionne brique
     * @param i numero
     */
    public void selectionneBrique(int i)
    {
        briqueSel=i;
        jLInfosBrique.setIcon(lstBriques[i]);
    }
    
    /**
     * Selection bonus
     * @param i numero
     */
    public void selectionneBonus(int i)
    {
        bonusSel=i;
        jLInfosBonus.setIcon(lstBonus[i]);
    }

    /**
     * Remplace brique
     * @param ligne ligne
     * @param colonne colone
     */
    void remplaceBrique(int ligne, int colonne)
    {
        //System.out.println("[REMPLACE BRIQUE] L= "+colonne +" C= "+ligne);
        boolean bonusex = false;
        // Partie Grille
        Case amodif = niv.getCase(ligne, colonne);
        amodif.setType(briqueSel);
        // Si la brique selectionner 0 ( emplacement vide )
        if(briqueSel==0)
        {
            // Si il y avait un bonus, on le retire
            if(amodif.getBonus()!=0)
            {
                amodif.setBonus(0);
                bonusex=true;
            }
        }
        niv.modCase(ligne, colonne, amodif);

        // Partie Interface
        JLayeredPane panneBrique = grilleIHM[ligne][colonne];//tab.getCase(colonne, ligne).getType()
        Component[] lstCompBri = panneBrique.getComponentsInLayer(1); // Liste des composants sur le layer 1 (normalement y'en a qu'un.)
        JLabel labelBrique = (JLabel) lstCompBri[0]; // Prend le composent numero 1 dans la liste et le cast pour retrouver notre JLabel
        labelBrique.setIcon(lstBriques[briqueSel]); // Change l'icon
        
        if(bonusex)
        {
            JLayeredPane panneBonus = grilleIHM[ligne][colonne];//tab.getCase(colonne, ligne).getType()
            Component[] lstCompBon = panneBonus.getComponentsInLayer(2); // Liste des composants sur le layer 1 (normalement y'en a qu'un.)
            JLabel labelBonus = (JLabel) lstCompBon[0]; // Prend le composent numero 1 dans la liste et le cast pour retrouver notre JLabel
            labelBonus.setIcon(lstBonus[0]); // Change l'icon
        }
    }

    /**
     * Supprime brique
     * @param ligne ligne
     * @param colonne colone
     */
    void supprimeBrique(int ligne, int colonne)
    {
        //System.out.println("[REMPLACE BRIQUE] L= "+colonne +" C= "+ligne);
        boolean bonusex = false;
        // Partie Grille
        Case amodif = niv.getCase(ligne, colonne);
        amodif.setType(0);
        // Si il y avait un bonus, on le retire
        if(amodif.getBonus()!=0)
        {
            amodif.setBonus(0);
            bonusex=true;
        }
        niv.modCase(ligne, colonne, amodif);

        // Partie Interface
        JLayeredPane panneBrique = grilleIHM[ligne][colonne];//tab.getCase(colonne, ligne).getType()
        Component[] lstCompBri = panneBrique.getComponentsInLayer(1); // Liste des composants sur le layer 1 (normalement y'en a qu'un.)
        JLabel labelBrique = (JLabel) lstCompBri[0]; // Prend le composent numero 1 dans la liste et le cast pour retrouver notre JLabel
        labelBrique.setIcon(lstBriques[0]); // Change l'icon
        
        if(bonusex)
        {
            JLayeredPane panneBonus = grilleIHM[ligne][colonne];//tab.getCase(colonne, ligne).getType()
            Component[] lstCompBon = panneBonus.getComponentsInLayer(2); // Liste des composants sur le layer 1 (normalement y'en a qu'un.)
            JLabel labelBonus = (JLabel) lstCompBon[0]; // Prend le composent numero 1 dans la liste et le cast pour retrouver notre JLabel
            labelBonus.setIcon(lstBonus[0]); // Change l'icon
        }
    }
    
    /**
     * Supprime bonus
     * @param ligne ligne
     * @param colonne colone
     */
    void supprimeBonus(int ligne, int colonne)
    {
        //System.out.println("[REMPLACE BONUS] L= "+colonne +" C= "+ligne);

        Case amodif = niv.getCase(ligne, colonne);
        if(amodif.getType()!=0) // Test si il y a une brique sur cette case. Si oui, on ne peut pas mettre de bonus.
        {
            amodif.setBonus(0);
            niv.modCase(ligne, colonne, amodif);

            // Partie Interface
            JLayeredPane panne = grilleIHM[ligne][colonne];//tab.getCase(colonne, ligne).getType()
            Component[] lbl = panne.getComponentsInLayer(2); // Liste des composants sur le layer 1 (normalement y'en a qu'un.)
            JLabel tmp = (JLabel) lbl[0]; // Prend le composent numero 1 dans la liste et le cast pour retrouver notre JLabel
            tmp.setIcon(lstBonus[0]); // Change l'icon
        }
        else
            JOptionPane.showMessageDialog(this, "Vous devez au prealable mettre une brique.", "Erreur", JOptionPane.WARNING_MESSAGE);
    }
    
    /**
     * Remplace bonus
     * @param ligne ligne
     * @param colonne colone
     */
    void remplaceBonus(int ligne, int colonne)
    {
        //System.out.println("[REMPLACE BONUS] L= "+colonne +" C= "+ligne);

        Case amodif = niv.getCase(ligne, colonne);
        if(amodif.getType()!=0) // Test si il y a une brique sur cette case. Si oui, on ne peut pas mettre de bonus.
        {
            amodif.setBonus(bonusSel);
            niv.modCase(ligne, colonne, amodif);

            // Partie Interface
            JLayeredPane panne = grilleIHM[ligne][colonne];//tab.getCase(colonne, ligne).getType()
            Component[] lbl = panne.getComponentsInLayer(2); // Liste des composants sur le layer 1 (normalement y'en a qu'un.)
            JLabel tmp = (JLabel) lbl[0]; // Prend le composent numero 1 dans la liste et le cast pour retrouver notre JLabel
            tmp.setIcon(lstBonus[bonusSel]); // Change l'icon
        }
        else
            JOptionPane.showMessageDialog(this, "Vous devez au prealable mettre une brique.", "Erreur", JOptionPane.WARNING_MESSAGE);
    }

    /**
     * Affiche grille du niveau
     * @param fichier fichier niveau
     */
    public void afficheNiveau(String fichier)
    {
        niv.charge(fichier);
        
        // Affichage de la grille
        for(int li=0;li<niv.getNbLig();li++)
        {
            for(int co=0;co<niv.getNbCol();co++)
            {
                JLayeredPane panne = grilleIHM[li][co];//tab.getCase(colonne, ligne).getType()
                Component[] lbl = panne.getComponentsInLayer(1); // Liste des composants sur le layer 1 (normalement y'en a qu'un.)
                JLabel lbll = (JLabel) lbl[0]; // Prend le composent numero 1 dans la liste et le cast pour retrouver notre JLabel
                lbll.setIcon(lstBriques[niv.getCase(li, co).getType()]); // Change l'icon
                
                Component[] lbl2 = panne.getComponentsInLayer(2); // Liste des composants sur le layer 1 (normalement y'en a qu'un.)
                JLabel lbll2 = (JLabel) lbl2[0]; // Prend le composent numero 1 dans la liste et le cast pour retrouver notre JLabel
                lbll2.setIcon(lstBonus[niv.getCase(li, co).getBonus()]); // Change l'icon
            }
        }
        
        jTScreen.setText(niv.getChemin());
    }
    
    /**
     * Nouvelle grille
     */
    public void newNiveau()
    {
        niv.reset();
        changerTitre();
        // Affichage de la grille
        for(int li=0;li<niv.getNbLig();li++)
        {
            for(int co=0;co<niv.getNbCol();co++)
            {
                JLayeredPane panne = grilleIHM[li][co];//tab.getCase(colonne, ligne).getType()
                Component[] lbl = panne.getComponentsInLayer(1); // Liste des composants sur le layer 1 (normalement y'en a qu'un.)
                JLabel lbll = (JLabel) lbl[0]; // Prend le composent numero 1 dans la liste et le cast pour retrouver notre JLabel
                lbll.setIcon(lstBriques[niv.getCase(li, co).getType()]); // Change l'icon
                
                Component[] lbl2 = panne.getComponentsInLayer(2); // Liste des composants sur le layer 1 (normalement y'en a qu'un.)
                JLabel lbll2 = (JLabel) lbl2[0]; // Prend le composent numero 1 dans la liste et le cast pour retrouver notre JLabel
                lbll2.setIcon(lstBonus[niv.getCase(li, co).getBonus()]); // Change l'icon
            }
        }
    }
    
    /**
     * Enregistrer grille
     * @param num numeo
     */
    public void enregistreNiveau(String num)
    {
        niv.enregistre(num);
        changerTitre();
    }
    
    /**
     * Change titre de la fenetre
     */
    public void changerTitre()
    {
    	String nom;
    	
        if( niv.getNiv() == 0 || niv.getNiv() == 999)
            nom = "Sans Titre";  	
        else
            nom = "Niveau "+niv.getNiv();

       setTitle("Editeur de niveaux ShootBreaker :: "+nom);
    }
    
    
    /**
     * Charger niveau
     */
    public void chargerNiveau()
    {
        String choix=new String();
        JFileChooser boiteCharge = new JFileChooser("Niveaux/");
        boiteCharge.setDialogTitle("Charger un niveau de ShootBreaker");
        boiteCharge.setFileSelectionMode(JFileChooser.FILES_ONLY);
        
        int returnVal = boiteCharge.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION)
        {
           choix =  boiteCharge.getSelectedFile().getName();
        }
        if(choix.length()>0)
        {
            afficheNiveau(choix);
            changerTitre();
        }
    }
    
    /**
     * Supression des fichiers temporaires
     */
    public void supprimerFichierTemp()
    {
    	File temp = new File("Niveaux/niveau999.sb");
    	temp.delete();
    }
    
    /**
     * Change le mode d'ecriture
     */
    public void changeMode()
    {
        if(colorise)
        {
            colorise=false;
            jLInfosMode.setText("Off");
            menuOptionsModeCont.setText("Activer le mode continue");
        }
        else
        {
            colorise = true;
            jLInfosMode.setText("On");
            menuOptionsModeCont.setText("Desactiver le mode continue");
        }
    }
    
    /**
     * Initialise les composants
     */
    private void initComponents() 
    {
        panelGrille 			= new javax.swing.JPanel();
        jTabbPane 				= new javax.swing.JTabbedPane();
        jLabel3 				= new javax.swing.JLabel();
        jLabel2 				= new javax.swing.JLabel();
        jLabel1 				= new javax.swing.JLabel();
        jLInfosMode 			= new javax.swing.JLabel();
        jLInfosBrique 			= new javax.swing.JLabel();
        jLInfosBonus 			= new javax.swing.JLabel();
        jLabel4 				= new javax.swing.JLabel();
        jMenuBar1 				= new javax.swing.JMenuBar();
        menuFichier 			= new javax.swing.JMenu();
        jMenuItem1 				= new javax.swing.JMenuItem();
        menuFichierQuitter 		= new javax.swing.JMenuItem();
        menuNiveau 				= new javax.swing.JMenu();
        menuNiveauCharger 		= new javax.swing.JMenuItem();
        menuNiveauEnregistrer 	= new javax.swing.JMenuItem();
        menuNiveauEnregistrerSS = new javax.swing.JMenuItem();
        menuNiveauTester 		= new javax.swing.JMenuItem();
        menuOptions 			= new javax.swing.JMenu();
        menuOptionsModeCont 	= new javax.swing.JMenuItem();
        jMenuBar2 				= new javax.swing.JMenuBar();
        menuFichier1 			= new javax.swing.JMenu();
        jMenuItem2 				= new javax.swing.JMenuItem();
        menuFichierQuitter1 	= new javax.swing.JMenuItem();
        menuNiveau1 			= new javax.swing.JMenu();
        menuNiveauCharger1 		= new javax.swing.JMenuItem();
        menuNiveauEnregistrer1 	= new javax.swing.JMenuItem();
        menuNiveauEnregistrerSS1= new javax.swing.JMenuItem();
        menuNiveauTester1 		= new javax.swing.JMenuItem();
        menuOptions1 			= new javax.swing.JMenu();
        menuOptionsModeCont1 	= new javax.swing.JMenuItem();
        jMenuBar3 				= new javax.swing.JMenuBar();
        menuFichier2 			= new javax.swing.JMenu();
        jMenuItem3 				= new javax.swing.JMenuItem();
        menuFichierQuitter2 	= new javax.swing.JMenuItem();
        menuNiveau2 			= new javax.swing.JMenu();
        menuNiveauCharger2 		= new javax.swing.JMenuItem();
        menuNiveauEnregistrer2	= new javax.swing.JMenuItem();
        menuNiveauEnregistrerSS2= new javax.swing.JMenuItem();
        menuNiveauTester2 		= new javax.swing.JMenuItem();
        menuOptions2 			= new javax.swing.JMenu();
        menuOptionsModeCont2 	= new javax.swing.JMenuItem();
        jTScreen 				= new javax.swing.JTextField();
        jBScreen 				= new javax.swing.JButton();
        jMenuBar4 				= new javax.swing.JMenuBar();
        menuFichier3 			= new javax.swing.JMenu();
        jMenuItem4 				= new javax.swing.JMenuItem();
        menuFichierQuitter3 	= new javax.swing.JMenuItem();
        menuNiveau3 			= new javax.swing.JMenu();
        menuNiveauCharger3 		= new javax.swing.JMenuItem();
        menuNiveauEnregistrer3 	= new javax.swing.JMenuItem();
        menuNiveauEnregistrerSS3= new javax.swing.JMenuItem();
        menuNiveauTester3 		= new javax.swing.JMenuItem();
        menuOptions3 			= new javax.swing.JMenu();
        menuOptionsModeCont3 	= new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Editeur de niveaux ShootBreaker :: Sans Titre");
        setBackground(new java.awt.Color(102, 153, 255));
        setMinimumSize(null);
        setResizable(false);

        panelGrille.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        javax.swing.GroupLayout panelGrilleLayout = new javax.swing.GroupLayout(panelGrille);
        panelGrille.setLayout(panelGrilleLayout);
        panelGrilleLayout.setHorizontalGroup(
            panelGrilleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 690, Short.MAX_VALUE)
        );
        panelGrilleLayout.setVerticalGroup(
            panelGrilleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 424, Short.MAX_VALUE)
        );

        jTabbPane.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jTabbPane.setMaximumSize(null);
        jTabbPane.setMinimumSize(null);

        jLabel3.setText("Bonus : ");

        jLabel2.setText("Brique : ");

        jLabel1.setText("Mode continue :");

        jLInfosMode.setText("Text");

        jLInfosBrique.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLInfosBrique.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(255, 51, 51)));

        jLInfosBonus.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLInfosBonus.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(255, 51, 51)));

        jLabel4.setText("Fond d'cran :");

        menuFichier.setText("Fichier");

        jMenuItem1.setText("Nouveau");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                jMenuItem1ActionPerformed(evt);
            }
        });
        menuFichier.add(jMenuItem1);

        menuFichierQuitter.setText("Quitter");
        menuFichierQuitter.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuFichierQuitterActionPerformed(evt);
            }
        });
        menuFichier.add(menuFichierQuitter);

        jMenuBar1.add(menuFichier);

        menuNiveau.setText("Niveau");

        menuNiveauCharger.setText("Charger");
        menuNiveauCharger.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauChargerActionPerformed(evt);
            }
        });
        menuNiveau.add(menuNiveauCharger);

        menuNiveauEnregistrer.setText("Enregistrer");
        menuNiveauEnregistrer.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauEnregistrerActionPerformed(evt);
            }
        });
        menuNiveau.add(menuNiveauEnregistrer);

        menuNiveauEnregistrerSS.setText("Enregistrer sous...");
        menuNiveauEnregistrerSS.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauEnregistrerSSActionPerformed(evt);
            }
        });
        menuNiveau.add(menuNiveauEnregistrerSS);

        menuNiveauTester.setText("Tester");
        menuNiveauTester.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauTesterActionPerformed(evt);
            }
        });
        menuNiveau.add(menuNiveauTester);

        jMenuBar1.add(menuNiveau);

        menuOptions.setText("Options");

        menuOptionsModeCont.setText("Activer mode continue");
        menuOptionsModeCont.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuOptionsModeContActionPerformed(evt);
            }
        });
        menuOptions.add(menuOptionsModeCont);

        jMenuBar1.add(menuOptions);

        menuFichier1.setText("Fichier");

        jMenuItem2.setText("Nouveau");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                jMenuItem1ActionPerformed(evt);
            }
        });
        menuFichier1.add(jMenuItem2);

        menuFichierQuitter1.setText("Quitter");
        menuFichierQuitter1.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuFichierQuitterActionPerformed(evt);
            }
        });
        menuFichier1.add(menuFichierQuitter1);

        jMenuBar2.add(menuFichier1);

        menuNiveau1.setText("Niveau");

        menuNiveauCharger1.setText("Charger");
        menuNiveauCharger1.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauChargerActionPerformed(evt);
            }
        });
        menuNiveau1.add(menuNiveauCharger1);

        menuNiveauEnregistrer1.setText("Enregistrer");
        menuNiveauEnregistrer1.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauEnregistrerActionPerformed(evt);
            }
        });
        menuNiveau1.add(menuNiveauEnregistrer1);

        menuNiveauEnregistrerSS1.setText("Enregistrer sous...");
        menuNiveauEnregistrerSS1.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauEnregistrerSSActionPerformed(evt);
            }
        });
        menuNiveau1.add(menuNiveauEnregistrerSS1);

        menuNiveauTester1.setText("Tester");
        menuNiveauTester1.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauTesterActionPerformed(evt);
            }
        });
        menuNiveau1.add(menuNiveauTester1);

        jMenuBar2.add(menuNiveau1);

        menuOptions1.setText("Options");

        menuOptionsModeCont1.setText("Activer mode continue");
        menuOptionsModeCont1.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuOptionsModeContActionPerformed(evt);
            }
        });
        menuOptions1.add(menuOptionsModeCont1);

        jMenuBar2.add(menuOptions1);

        menuFichier2.setText("Fichier");

        jMenuItem3.setText("Nouveau");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                jMenuItem1ActionPerformed(evt);
            }
        });
        menuFichier2.add(jMenuItem3);

        menuFichierQuitter2.setText("Quitter");
        menuFichierQuitter2.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuFichierQuitterActionPerformed(evt);
            }
        });
        menuFichier2.add(menuFichierQuitter2);

        jMenuBar3.add(menuFichier2);

        menuNiveau2.setText("Niveau");

        menuNiveauCharger2.setText("Charger");
        menuNiveauCharger2.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauChargerActionPerformed(evt);
            }
        });
        menuNiveau2.add(menuNiveauCharger2);

        menuNiveauEnregistrer2.setText("Enregistrer");
        menuNiveauEnregistrer2.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauEnregistrerActionPerformed(evt);
            }
        });
        menuNiveau2.add(menuNiveauEnregistrer2);

        menuNiveauEnregistrerSS2.setText("Enregistrer sous...");
        menuNiveauEnregistrerSS2.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauEnregistrerSSActionPerformed(evt);
            }
        });
        menuNiveau2.add(menuNiveauEnregistrerSS2);

        menuNiveauTester2.setText("Tester");
        menuNiveauTester2.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauTesterActionPerformed(evt);
            }
        });
        menuNiveau2.add(menuNiveauTester2);

        jMenuBar3.add(menuNiveau2);

        menuOptions2.setText("Options");

        menuOptionsModeCont2.setText("Activer mode continue");
        menuOptionsModeCont2.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuOptionsModeContActionPerformed(evt);
            }
        });
        menuOptions2.add(menuOptionsModeCont2);

        jMenuBar3.add(menuOptions2);

        jTScreen.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N

        jBScreen.setText("Parcourir");
        jBScreen.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                jBScreenActionPerformed(evt);
            }
        });

        menuFichier3.setText("Fichier");

        jMenuItem4.setText("Nouveau");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                jMenuItem1ActionPerformed(evt);
            }
        });
        menuFichier3.add(jMenuItem4);

        menuFichierQuitter3.setText("Quitter");
        menuFichierQuitter3.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuFichierQuitterActionPerformed(evt);
            }
        });
        menuFichier3.add(menuFichierQuitter3);

        jMenuBar4.add(menuFichier3);

        menuNiveau3.setText("Niveau");

        menuNiveauCharger3.setText("Charger");
        menuNiveauCharger3.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauChargerActionPerformed(evt);
            }
        });
        menuNiveau3.add(menuNiveauCharger3);

        menuNiveauEnregistrer3.setText("Enregistrer");
        menuNiveauEnregistrer3.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauEnregistrerActionPerformed(evt);
            }
        });
        menuNiveau3.add(menuNiveauEnregistrer3);

        menuNiveauEnregistrerSS3.setText("Enregistrer sous...");
        menuNiveauEnregistrerSS3.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauEnregistrerSSActionPerformed(evt);
            }
        });
        menuNiveau3.add(menuNiveauEnregistrerSS3);

        menuNiveauTester3.setText("Tester");
        menuNiveauTester3.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuNiveauTesterActionPerformed(evt);
            }
        });
        menuNiveau3.add(menuNiveauTester3);

        jMenuBar4.add(menuNiveau3);

        menuOptions3.setText("Options");

        menuOptionsModeCont3.setText("Activer mode continue");
        menuOptionsModeCont3.addActionListener(new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                menuOptionsModeContActionPerformed(evt);
            }
        });
        menuOptions3.add(menuOptionsModeCont3);

        jMenuBar4.add(menuOptions3);

        setJMenuBar(jMenuBar4);

        GridLayout bl = new GridLayout(3,1);
        
        JPanel jp = new JPanel();
        jp.setLayout( bl );
        jp.add( jLabel4 );
        jp.add( jTScreen );
        jp.add( jBScreen );
        
        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(jTScreen, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jTabbPane, javax.swing.GroupLayout.PREFERRED_SIZE, 129, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(layout.createSequentialGroup()
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel2)
                                            .addComponent(jLabel1)
                                            .addComponent(jLabel3))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                            .addComponent(jLInfosMode, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addComponent(jLInfosBonus, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addComponent(jLInfosBrique, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addComponent(jLabel4))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 16, Short.MAX_VALUE)
                                .addComponent(panelGrille, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(38, 38, 38)
                        .addComponent(jBScreen)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(panelGrille, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jTabbPane, javax.swing.GroupLayout.PREFERRED_SIZE, 326, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLInfosMode, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLInfosBrique, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLInfosBonus, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel4)
                        .addGap(1, 1, 1)
                        .addComponent(jTScreen, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBScreen)
                .addGap(22, 22, 22))
        );

        getAccessibleContext().setAccessibleName("");

        pack();
    }

    /**
     * Menu Fichier Quitter
     * @param evt
     */
    private void menuFichierQuitterActionPerformed(java.awt.event.ActionEvent evt) 
    {
        System.exit(0);
    }

    /**
     * Menu Niveau Charger
     * @param evt
     */
    private void menuNiveauChargerActionPerformed(java.awt.event.ActionEvent evt) 
    {
        chargerNiveau();
    }

    /**
     * Menu Niveau Enregistrer Sous
     * @param evt
     */
    private void menuNiveauEnregistrerSSActionPerformed(java.awt.event.ActionEvent evt) 
    {
        String nv = new String();
        nv = JOptionPane.showInputDialog(this, "Entrez le numero du niveau", "Enregistrer un niveau",JOptionPane.INFORMATION_MESSAGE);
        // showInputDialog renvoie null si Annulation
        if(nv!=null)
            if(nv.length()>0)
                enregistreNiveau(nv);
    }

    /**
     * Menu Niveau Tester
     * @param evt
     */
    private void menuNiveauTesterActionPerformed(java.awt.event.ActionEvent evt) 
    {                                                 
        try
        {
            if( niv.getNiv() == 0 ) // Si le fichier est "Sans Titre"
            {
                // Enregistre dans un fichier temporaire
                enregistreNiveau("999");

                Process proc;

                // Lancement du programme
                if ( System.getProperty("file.separator").equals( "/" ) ) 
                        proc = Runtime.getRuntime().exec("./ShootBreaker.sh 999");
                else
                        proc = Runtime.getRuntime().exec("./ShootBreaker.exe 999");	    			

                // On attend la fin du processus
                proc.waitFor();

                // On supprime le fichier niveau999.sb
                supprimerFichierTemp();

                // Retourne aux valeurs pr�c�dent le test
                niv.setNiv( 0 ); 

                // Change Titre
                changerTitre();
            }
            else // Si le fichier a un nom on le sauvegarde avant de le tester
            {
                enregistreNiveau(Integer.toString(niv.getNiv()));

                Process proc;

                // Lancement du programme
                if ( System.getProperty("file.separator").equals( "/" ) ) 
                        proc = Runtime.getRuntime().exec("./ShootBreaker.sh "+niv.getNiv());
                else
                        proc = Runtime.getRuntime().exec("./ShootBreaker.exe "+niv.getNiv());	 

                proc.waitFor();
            }
        }
        catch (Exception e)
        {
            System.err.println("[ERREUR] "+e.getMessage());
            e.printStackTrace();
        }
    }

    
    /**
     * Menu fichier nouveau
     * @param evt
     */
    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) 
    {
        newNiveau();
    }

    /**
     * Menu Niveau Enregistrer
     * @param evt
     */
    private void menuNiveauEnregistrerActionPerformed(java.awt.event.ActionEvent evt) 
    {
        if(niv.getNiv()!=0 && niv.getNiv()!=999)
            enregistreNiveau(new Integer(niv.getNiv()).toString());
        else
            menuNiveauEnregistrerSSActionPerformed(evt);
    }

    /**
     * Menu Options Mode continue
     * @param evt
     */
    private void menuOptionsModeContActionPerformed(java.awt.event.ActionEvent evt) 
    {
        changeMode();
    }

    
	private void jBScreenActionPerformed(java.awt.event.ActionEvent evt) 
	{
        File ff = null;

        JFileChooser boiteCharge = new JFileChooser("Images/Niveaux/");
        boiteCharge.setDialogTitle("Choisir un fond de niveau ShootBreaker");
        boiteCharge.setFileSelectionMode(JFileChooser.FILES_ONLY);
        
        int returnVal = boiteCharge.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION)
        {
           ff =  boiteCharge.getSelectedFile();
        }
        
        if(ff.getPath().length()>0)
        {
            String s = ff.getPath();
            String chemin = s.substring(s.indexOf("Images")).replace("\\","/");
            niv.setChemin(chemin);
            jTScreen.setText(chemin);
        }

    
	}
    
    /**
     * Lancement de l'editeur
     */
    public static void main(String args[]) 
    {
        java.awt.EventQueue.invokeLater(new Runnable() 
        {
            public void run() 
            {
                new Editeur().setVisible(true);
            }
        });
    }
    

    
}
