package editeur;

/**
 * 
 * @author Simon Mahieux et Jerome Baudoux
 *
 */
public class Grille 
{
    private static int nbcolonne =   24;
    private static int nbligne  =   29;
    Case grille[][];
    
    /**
     * Constructeur d'une grille
     */
    public Grille()
    {
        grille=new Case[nbligne][nbcolonne];
        init();
    }

    /**
     * Initialise la grille
     */
    public void init()
    {
        for(int li=0;li<grille.length;li++)
        {
            for(int co=0;co<grille[li].length;co++)
            {
                grille[li][co]=new Case(0,0);
            }
        }
    }
    
    /**
     * Renvoie une chaine de caractere definnissant la grille
     */
    public String toString()
    {
        String res = new String();
        
        for(int i=0;i<grille.length;i++)
        {
            for(int e=0;e<grille[i].length;e++)
            {
                Case tmp = grille[i][e];
                res+=tmp.toString();
                if(e!=grille[i].length-1)
                    res+=" ";
            }
            res+=System.getProperty("line.separator");
        }
        return res;
    }

    /**
     * Modifie la valeur de la case
     * @param ligne ligne
     * @param colonne colone
     * @param nCase nouvelle case
     */
    public void modCase(int ligne, int colonne, Case nCase)
    {
        //System.out.println("[DEBUG] modCase => L:"+ligne+" C:"+colonne);
        grille[ligne][colonne]=nCase;
    }
    
    /**
     * Recupere la case
     * @param ligne ligne
     * @param colonne colone
     * @return case
     */
    public Case getCase(int ligne, int colonne)
    {
        //System.out.println("[DEBUG] getCase => L:"+ligne+" C:"+colonne);
        return grille[ligne][colonne];
    }
    
    /**
     * Renvoie la taille de la grille
     * @return taille de la grille
     */
    public int getNbCol()
    {
        return nbcolonne;
    }
    
    /**
     * Renvoie la taille de la grille
     * @return taille de la grille
     */
    public int getNbLig()
    {
        return nbligne;
    }

    /**
     * Main test
     * @param args
     */
    public static void main(String[] args) 
    {
        Grille tab = new Grille();
        System.out.println(tab.toString());
        Case a = new Case(2,5);
        tab.modCase(1,0, a);
        Case t = tab.getCase(1,0);
        System.out.println(t.toString());
        System.out.println(tab.toString());
    }
}
