package elements;

import java.util.Random;

import controles.ImageManager;

public class Bonus extends ObjetMobile implements Destructible
{
	public static int AUGMENTE_TAILLE 	= 1;
	public static int DIMINUE_TAILLE 	= 2;
	public static int DIMINUE_VITESSE 	= 3;
	public static int AUGMENTE_VITESSE 	= 4;
	public static int AJOUTE_VIE 		= 5;
	public static int RETIRE_VIE 		= 6;
	
	private int 	  type;
	private boolean   vivant;
	
	/**
	 * Construction d'un bonus
	 * @param valeurX position en X
	 * @param valeurY position en Y
	 * @param valeurVitesse vitesse
	 */
	public Bonus(int valeurX, int valeurY, float valeurVitesse, int t) 
	{
		// CONSTRUCTEUR PARENT
		super(valeurX, valeurY, valeurVitesse, 90);
		
		// INIT
		type 	= t;
		img 	= ImageManager.getImagemanager().getImageBonus( (t-1) );
		vivant 	= true;
	}
	
	
	/**
	 * Renvoie le type du bonus
	 * @return type du bonus
	 */
	public int getType()
	{
		return type;
	}
	
	
	// FONCTIONS

	public void enleverEnergie() 
	{ 
		enleverEnergie(1);
	}
	
	public void enleverEnergie(int e) 
	{
		vivant = false;
	}
	
	public boolean estMort() 
	{
		return !vivant;
	}
	
	public int getEnergie() 
	{
		return 1;
	}

	public void tuer()
	{
		vivant = false;
	}
	
	/**
	 * Raffraichir les positions
	 * @param temps temps de la derniere frame
	 */
	public void raffraichir( long temps )
	{		
		
		float alea = new Random().nextFloat()*2-1;
		if( type == RETIRE_VIE )
			super.raffraichir(temps*3,alea);
		else
			super.raffraichir(temps);
		
		if( y > 768 )
			tuer();
	}

}
