package elements;

import controles.ImageManager;

public class Tir extends ObjetMobile
{
	/**
	 * Le tir est il toujours vivant
	 */
	private boolean vivant;
	
	public static int TIR_JOUEUR = 0;
	public static int TIR_ENNEMI = 1;
	
	/**
	 * Tir generique
	 * @param valeurX position en X
	 * @param valeurY position en Y
	 * @param valeurVitesse vitesse
	 * @param valeurAngle angle
	 */
	public Tir(int valeurX, int valeurY, float valeurVitesse, int typeDeTir) 
	{
		super(valeurX, valeurY, valeurVitesse, 90);
		
		// SI TIR JOUEUR, ON IMPOSE L'ANGLE A -90 ( Vers le Haut )
		if( typeDeTir == TIR_JOUEUR)
			setAngle( -90 );
		
		// CHOIX DE l'IMAGE
		img = ImageManager.getImagemanager().getImageTir(typeDeTir);
		
		// LE TIR EST VIVANT
		vivant = true;
	}
	
	// GETTERS
	
	/**
	 * Renvoie vrai si le tir est vivant
	 * @return vrai si le tir est vivant
	 */
	public boolean estMort()
	{
		return ! vivant;
	}
	
	// FONCTION
	
	/**
	 * Tue le tir
	 */
	public void tuer()
	{
		vivant = false;
	}
	
	public void raffraichir( long temps )
	{
		super.raffraichir(temps);
		
		// SI LE TIR DEPASSE L'ECRAN, ON LE TUE
		if( y < 0 - getHeight() )
			tuer();
	}
	
	

}
