package elements.ennemis;

import java.awt.geom.Area;

import controles.SonManager;

import elements.Balle;

public class EnnemiFantome extends Ennemi
{
	/**
	 * Creation d'un ennemi basique
	 * @param valeurX position en x
	 * @param valeurY position en y
	 * @param en energie
	 */
	public EnnemiFantome(int valeurX, int valeurY, int en, int b ) 
	{
		super(valeurX, valeurY, 9, en, b);
		points = 3;
	}
	
	/**
	 * Cet ennemi ne peut pas tirer
	 */
	public boolean pretaTirer()
	{
		return false;
	}
	
	/**
	 * Traite la collision entre l'ennemi et la balle
	 * @param b balle
	 * @param degats l'ennemi subira il des degats
	 */
	public boolean collision( Balle b , boolean degats)
	{
		// RECUPERATION DES AIRES
		Area air 	= getArea();

		// INTERSECTION DES AIRES
		air.intersect( b.getArea() );

		// COLLISION HAUT GAUCHE
		if( ! air.isEmpty()  )
		{
			//EFFECTUE LES OPERATIONS
			if( degats )
				enleverEnergie();	
			
			// JOUE LES SONS NECESSAIRES
			SonManager.getSonManager().jouerToucheEnnemi();
			
			if( energie <= 0 )
				tuer();
		}
		
		return false;
	}

	
}
