package elements.ennemis;

import elements.Balle;
import elements.Tir;

public class EnnemiInvincible extends Ennemi
{
	/**
	 * Ennemi indestructible
	 * @param valeurX position x
	 * @param valeurY position y
	 */
	public EnnemiInvincible(int valeurX, int valeurY, int b) 
	{
		super(valeurX, valeurY, 8, 1, b);
	}

	/**
	 * Cet ennemi ne peut pas tirer
	 */
	public boolean pretaTirer()
	{
		return false;
	}
	
	/**
	 * Ne peut pas etre detruit par des tirs
	 * @param t tir
	 */
	public void collision( Tir t)
	{
		collision(t,false);	
	}	
	
	/**
	 * Ne peut pas etre detruit par des balles
	 * @param t tir
	 */
	public boolean collision( Balle b )
	{
		return collision(b,false);	
	}	
}
