package menus;

import java.awt.Graphics2D;
import javax.swing.ImageIcon;

import controles.ClavierManager;
import controles.SonManager;
import elements.Dessinable;
import elements.Raffraichissable;


/**
 * 
 * @author Simon Mahieux et Jerome Baudoux
 *
 */
public class Menu implements Dessinable, Raffraichissable
{
	private static final long serialVersionUID = 1L;

	protected ImageIcon[] menu;
	protected ImageIcon[] menuChoix;
	
	protected String typeDeMenu;	
	protected int choix;
	
	protected ImageIcon fond;
	
	// dures
	protected long boucle;
	protected long dernierDeplacement = 0;
	
	
	// clavier
	ClavierManager clavier;	
	
	public Menu()
	{
		clavier = ClavierManager.getClavierManager();
	}
	
	public void raffraichir(long t) 
	{
		// dure
		boucle = System.currentTimeMillis();
		
		
		// SI AUCUNE TOUCHE N'EST APPUYE ON REMET LE COMPTEUR A ZERO
		if( ! clavier.estHaut() && ! clavier.estBas() && ! clavier.estGauche() && ! clavier.estDroite())
			dernierDeplacement = boucle - 300;			

		// DEPLACEMENT DANS LE MENU
		if ( boucle - dernierDeplacement > 200 ) 
		{
			// Si haut
			if (clavier.estHaut()) 
			{
				choix = choix-1;
				
				if( choix < 0)
					choix = menu.length - 1;
				
				dernierDeplacement = boucle;
				
				//SON
				SonManager.getSonManager().jouerBeepMenu();
			}
			// Si Bas
			else if (clavier.estBas()) 
			{
				choix = (choix+1)%menu.length;
				dernierDeplacement = boucle;	
				
				//SON
				SonManager.getSonManager().jouerBeepMenu();
			}	
		}
	}		
	
	public void dessiner(Graphics2D graphics2D) 
	{
		graphics2D.drawImage( fond.getImage(),0,0, null );
		
		// MENU
		for (int i = 0 ; i < menu.length ; i++) 
			if (i == choix) 
				graphics2D.drawImage(menuChoix[i].getImage(), 760, 165+i*35, null);
			else 
				graphics2D.drawImage(menu[i].getImage()		, 760, 165+i*35, null);
	}	

	public String getTypeDeMenu()
	{
		return typeDeMenu;
	}
	
}
