package menus;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Toolkit;
import java.io.FileInputStream;
import java.util.Properties;
import javax.swing.ImageIcon;

/**
 * 
 * @author Simon Mahieux et Jerome Baudoux
 *
 */
public class MenuAide extends Menu
{
	private static final long serialVersionUID = 1L;
	private String[] bonus;
	private String[] ennemis;
	
	private ImageIcon[] imagesEnnemis;
	private ImageIcon[] imagesBonus;

	/**
	 * Cree un MenuScore
	 */
	public MenuAide()
	{
		menu 			= null;
		menuChoix 		= new ImageIcon[1];
		menuChoix[0] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/retour1.png"));
		bonus			= new String[6];
		ennemis			= new String[9];
		
		lireDescription();
		
		typeDeMenu 		= "MenuAide";
		fond 			= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/aide.png"));
		
		imagesEnnemis	= new ImageIcon[9];
		for( int i=0; i<ennemis.length; i++)
			imagesEnnemis[i] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Ennemis/"+(i+1)+".png"));
		
		imagesBonus		= new ImageIcon[6];
		for( int i=0; i<imagesBonus.length; i++)
			imagesBonus[i] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Elements/Bonus/"+(i+1)+".png"));
	}
	
	/**
	 * Lis les scores
	 */
	public void lireDescription()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		
		try
		{
			fichier = new FileInputStream("Data/briques.sb");
			lecteur.load(fichier);
			fichier.close();

			for( int i=0;i<ennemis.length;i++)
				ennemis[i] =  lecteur.getProperty("Brique_"+(i+1));
		}
		catch( Exception e)
		{
			for( int i=0;i<ennemis.length;i++)
			{
				ennemis[i] 		= "Inconnu";
			}
		}
		
		try
		{
			fichier = new FileInputStream("Data/bonus.sb");
			lecteur.load(fichier);
			fichier.close();

			for( int i=0;i<bonus.length;i++)
				bonus[i] =  lecteur.getProperty("Bonus_"+(i+1));
		}
		catch( Exception e)
		{
			for( int i=0;i<bonus.length;i++)
			{
				bonus[i] 		= "Inconnu";
			}
		}		
	}	
	
	/**
	 * Gere les raffraichissement
	 * @param t temps
	 */
	public void raffraichir( long temps ) {}
	
	/**
	 * Dessine le Menu
	 */
	public void dessiner(Graphics2D graphics2D) 
	{
		// FOND
		graphics2D.drawImage( fond.getImage(),0,0, null );
		
		// RETOUR
		graphics2D.drawImage( menuChoix[0].getImage(), 760, 282, null );
		
		// POSITION
		graphics2D.setFont(new Font(Font.MONOSPACED, Font.BOLD, 12));		
		graphics2D.setColor(Color.black);	

		// ENNEMIS
		for( int i=0; i<ennemis.length; i++)
		{
			graphics2D.drawImage( imagesEnnemis[i].getImage(), 80, 325 + i*35, null );	
			graphics2D.drawString(ennemis[i], 130, 339 + i*35);
		}
		
		// BONUS
		for( int i=0; i<bonus.length; i++)
		{
			graphics2D.drawImage( imagesBonus[i].getImage(), 470, 325 + i*35, null );	
			graphics2D.drawString(bonus[i], 500, 339 + i*35);
		}
	}	
	
	/**
	 * Retour au menu principal
	 * @return
	 */
	public boolean menuPrincipal()
	{
		return clavier.estEntrer() && choix == 0 || clavier.estEchappe();
	}
}
