package menus;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Toolkit;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;
import java.awt.event.KeyEvent;
import javax.swing.ImageIcon;

import controles.SonManager;


/**
 * 
 * @author Simon Mahieux et Jerome Baudoux
 *
 */
public class MenuClavier extends Menu
{
	private static final long serialVersionUID = 1L;

	private boolean 	attendreAppuyeTouche;
	private boolean 	toucheDejaPrise;
	private String[] 	touches;
	private int[] 		numTouches;


	/**
	 * constructeur
	 */
	public MenuClavier()
	{
	
		fond 		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/options.png"));				
		touches 	= new String[] {"HAUT","BAS","GAUCHE","DROITE","ACTION","TILT"};
		
		menu 			= new ImageIcon [2];
		menuChoix 		= new ImageIcon [2];
		menu[0]		 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/valider0.png"	));
		menu[1]		 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/retour0.png"		));
		menuChoix[0] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/valider1.png"	));
		menuChoix[1] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/retour1.png"		));
		
		typeDeMenu 	= "MenuClavier";	
		
		numTouches = clavier.getListeTouches();
	}
	
	
	/**
	 * Ecrit dans le fichier clavier.dat
	 */
	public void ecrireTouches()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		FileOutputStream fichier2;
		try
		{
			fichier = new FileInputStream("Data/clavier.sb");
			lecteur.load(fichier);
			fichier.close();

			lecteur.setProperty("haut"	,Integer.toString( numTouches[0] ) );	
			lecteur.setProperty("bas"	,Integer.toString( numTouches[1] ) );				
			lecteur.setProperty("gauche",Integer.toString( numTouches[2] ) );	
			lecteur.setProperty("droite",Integer.toString( numTouches[3] ) );	
			lecteur.setProperty("tir"	,Integer.toString( numTouches[4] ) );	
			lecteur.setProperty("tilt"	,Integer.toString( numTouches[5] ) );	
			
			fichier2 = new FileOutputStream("Data/clavier.sb");
			lecteur.store( fichier2 , null);
			fichier2.close();
			
		}
		catch( Exception e){}
	}	
	
	
	/**
	 * raffraichit le menu
	 * @param t temps
	 */
	public void raffraichir( long t ) 
	{
		// dure
		boucle = System.currentTimeMillis();
		
		// Si ni haut ni bas n'est press, on remet le compteur a zero
		if( ! clavier.estHaut() && ! clavier.estBas() && ! clavier.estGauche() && ! clavier.estDroite())
			dernierDeplacement = boucle - 300;			

		// dplacement dans le menu
		if ( boucle - dernierDeplacement > 200 ) 
		{
			// SI ON EST PAS EN MODE COUTE
			if( ! attendreAppuyeTouche )
			{
				// Si haut
				if( clavier.estHaut() ) 
				{
					choix = choix-1;
					
					if( choix < 0)
						choix = touches.length + 1;
					
					dernierDeplacement 	= boucle;
					toucheDejaPrise 	= false;		
					

					SonManager.getSonManager().jouerBeepMenu();
				}
				// Si Bas
				else if( clavier.estBas() ) 
				{
					choix = (choix+1)%(touches.length + 2);
					
					dernierDeplacement 	= boucle;
					toucheDejaPrise 	= false;	
					
					SonManager.getSonManager().jouerBeepMenu();
				}
				else if( clavier.estEntrer() && choix < numTouches.length ) 
				{
					clavier.validerEntrer();
					attendreAppuyeTouche 	= true;
					toucheDejaPrise 		= false;										
				}			
			}
			else
			{
				
				// MAPPAGE DE TOUCHES
				if( clavier.getDerniereToucheAppuye() != 27 && clavier.getDerniereToucheAppuye() != 10)
				{
					boolean ok = true;				
					
					// VERIF QUE LA TOUCHE N'EST PAS DEJA PRISE
					for( int i=0; i<numTouches.length; i++)
						if( clavier.getDerniereToucheAppuye() == numTouches[i] && choix != i)
							ok = false;
					
					//SI OK
					if( ok )
						numTouches[choix] = clavier.getDerniereToucheAppuye();
					else
						toucheDejaPrise = true;
					
					attendreAppuyeTouche = false;
					clavier.validerTout();
				}
			}
			
			
		}
	}		
	
	/**
	 * Dessine le menu
	 * @param graphics2D flux
	 */
	public void dessiner(Graphics2D graphics2D) 
	{
		// FOND
		graphics2D.drawImage( fond.getImage(),0,0, null );
		
		// POLICE
		graphics2D.setFont(new Font(Font.MONOSPACED, Font.BOLD, 16));		
		
		// MENU TOUCHES
		for( int i=0; i< touches.length; i++ )
		{
			if( i == choix )
				graphics2D.setColor( Color.red );
			else
				graphics2D.setColor( Color.black );
				
			if( i < numTouches.length )
				if( KeyEvent.getKeyText( numTouches[i] ).length() > 10 )
					graphics2D.drawString( ":   "+KeyEvent.getKeyText( numTouches[i] ).subSequence(0,8), 830, 175 + i*20);
				else
					graphics2D.drawString( ":   "+KeyEvent.getKeyText( numTouches[i] ), 830, 175 + i*20);				

			graphics2D.drawString( touches[i], 760, 175 + i*20 );				
		}
		
		// MENU
		for( int i = 0 ; i < menu.length ; i++ ) 
			if (i == choix - numTouches.length) 
				graphics2D.drawImage(menuChoix[i].getImage(), 760, 285+i*35, null);
			else 
				graphics2D.drawImage(menu[i].getImage()		, 760, 285+i*35, null);
		
		
		
		//PRESSEZ UNE TOUCHE
		if( attendreAppuyeTouche )
		{
			graphics2D.setColor  ( Color.black );		
			graphics2D.drawString( "APPUYEZ  SUR" , 795, 400);			
			graphics2D.drawString( "UNE   TOUCHE" , 795, 430);			
			graphics2D.drawString( "NON ASSIGNEE" , 795, 460);					
		}

		// ERREUR TOUCHE DEJA PRISE
		if( toucheDejaPrise )
		{
			graphics2D.setColor  ( Color.black );		
			graphics2D.drawString( "ERREUR TOUCHE", 788, 400);				
			graphics2D.drawString( "DEJA ASSIGNEE", 788, 430);							
		}		
		
	}	

	
	/**
	 * Retour aux options
	 * @return
	 */
	public boolean menuOptions()
	{
		// SORTIE DU MENU
		if( clavier.estEntrer() && ( choix == numTouches.length + 1 || choix == numTouches.length ) || clavier.estEchappe()  )
		{
			// ENREGISTREMENT
			if( choix == numTouches.length )
			{
				ecrireTouches();
				clavier.lireTouches();		
			}
			
			clavier.validerTout();
			return true;
		}
		
		return false;
	}	
	
	
}

