package menus;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

import controles.ClavierManager;
import controles.Environnement;
import controles.ImageManager;

/**
 * 
 * @author Simon Mahieux et Jerome Baudoux
 *
 */
public class MenuDemandeNom
{
	private char[] 		nom;
	private int 		score;
	
	private String[] 	scores;
	private String[] 	nomsScores;
	
	private int 		choix;
	private long 		boucle;
	private long 		dernierDeplacement = 0;
	
	private boolean 	ok;
	
	private ClavierManager clavier;
	
	/**
	 * Cree un menu de demande de nom
	 * @param sc
	 */
	public MenuDemandeNom()
	{
		scores 		= new String[5];
		nomsScores	= new String[5];
		nom 		= new char[3];
		nom[0] 		= nom[1] = nom[2] = 'A';		
		
		ok 			= false;
		score 		= Environnement.getEnvironnement().getScore();		
 		choix 		= 0;
		clavier 	= ClavierManager.getClavierManager();
		
		chargerScore();
	}
	
	/**
	 * Charge le fichier score
	 */
	private void chargerScore()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		
		try
		{
			fichier = new FileInputStream("Data/scores.sb");
			lecteur.load(fichier);
			fichier.close();
			
			for( int i=0; i<scores.length; i++)
				scores[i] = lecteur.getProperty("score"+(i+1));
			
			for( int i=0; i<scores.length; i++)
				nomsScores[i] = lecteur.getProperty("nick"+(i+1));			
		}
		catch( Exception e)
		{
			for( int i=0; i<scores.length; i++)
				scores[i] = lecteur.getProperty("0");
			
			for( int i=0; i<scores.length; i++)
				nomsScores[i] = lecteur.getProperty("AAA");	
		}	
		
		// REGARDE SI NOTRE SCORE EST MIEUX QUE CEUX DANS LA LISTE
		if( score <= Integer.parseInt(scores[scores.length-1]) )
			ok = true;
	}
	
	/**
	 * Enregistre le score
	 */
	private void enregistrerScore()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		FileOutputStream fichier2;
		Boolean scoreMis = false;
		
		try
		{
			fichier = new FileInputStream("Data/scores.sb");
			lecteur.load(fichier);
			fichier.close();

			// PARCOURS LES SCORES
			for( int i=0,j=0; i<scores.length; i++)
			{
				
				if( Integer.parseInt( scores[j] ) > score || scoreMis )
				{
					lecteur.setProperty("score"+(i+1), scores[j] );	
					lecteur.setProperty("nick"+(i+1), nomsScores[j] );						
					j++;
				}
				else
				{
					lecteur.setProperty("score"+(i+1), Integer.toString( score ) );
					lecteur.setProperty("nick"+(i+1), ""+nom[0]+nom[1]+nom[2] );						
					scoreMis = true;
				}

			}
			
			fichier2 = new FileOutputStream("Data/scores.sb");
			lecteur.store( fichier2 , null);
			fichier2.close();
			
		}
		catch( Exception e){}		
	}
	
	
	/**
	 * Raffraichit les positions
	 * @param t temps
	 */
	public void raffraichir( long t )
	{
		boucle = System.currentTimeMillis();

		// SI NI HAUT NI BAS PRESSE ON RAZ LE CONTEUR
		if( ! clavier.estHaut() && ! clavier.estBas() && ! clavier.estGauche() && ! clavier.estDroite())
			dernierDeplacement = boucle - 300;			

		// DEPLACEMENT
		if ( boucle - dernierDeplacement > 200 ) 
		{
			// HAUT
			if (clavier.estHaut()) 
			{
				nom[choix]--;
				
				if( nom[choix] < 'A')
					nom[choix] = 'Z';
				
				dernierDeplacement = boucle;
			}
			// BAS
			else if (clavier.estBas()) 
			{
				nom[choix]++;

				if( nom[choix] > 'Z')
					nom[choix] = 'A';
				
				dernierDeplacement = boucle;				
			}	
		}	
		
		// VALIDE
		if( clavier.estEntrer() )
		{
			if ( choix < 2 )
			{
				clavier.validerEntrer();
				choix++;
			}
			else
			{
				ok = true;
				clavier.validerEntrer();
				enregistrerScore();
			}
		}
	}
	
	/**
	 * Retourne au menu principal
	 * @return
	 */
	public boolean menuPrincipal()
	{
		return ok;
	}
	
	/**
	 * Dessine le menu
	 * @param g flux
	 */
	public void dessiner( Graphics2D graphics2D )
	{
		graphics2D.drawImage( ImageManager.getImagemanager().getImageInfos(5).getImage(), 362, 284, null );
		
		graphics2D.setColor( Color.WHITE );	
		graphics2D.setFont(new Font(Font.MONOSPACED, Font.BOLD, 30));			

		for( int i=0; i<=choix; i++)
			graphics2D.drawString( Character.toString( nom[i] ), 465 + 30*i, 420);
	}
	
}
