package menus;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Toolkit;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;
import java.util.Vector;

import javax.swing.ImageIcon;

/**
 * 
 * @author Simon Mahieux et Jerome Baudoux
 *
 */
public class MenuOptions extends Menu
{
	
	private static final long serialVersionUID = 1L;

	private int nombreContinues;
	private int res;
    private int isFullScreen;
    
    private Vector<String> resolution; 
	
    /**
     * Constructeur
     */
	public MenuOptions()
	{
		menu 			= new ImageIcon [5];
		menuChoix 		= new ImageIcon [5];
		
		menu[0]		 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/continues0.png"	));
		menu[1]		 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/blank.png"	));
		menu[2]		 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/fullScreen0.png"	));
		menu[3]		 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/clavier0.png"		));
		menu[4]		 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/retour0.png"		));
		
		menuChoix[0] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/continues1.png"	));
		menuChoix[1] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/blank.png"	));
		menuChoix[2] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/fullScreen1.png"	));
		menuChoix[3] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/clavier1.png"		));
		menuChoix[4] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/retour1.png"		));
		
		fond 			= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/options.png"				));	
		
		resolution = new Vector<String>();
		resolution.add("640 x 480");
		resolution.add("800 x 600"); 
		resolution.add("1024 x 768"); 
		resolution.add("1280 x 1024"); 
		resolution.add("1600 x 1200");

		typeDeMenu 	= "MenuOptions";	
		
		res 		= 0;
		
		// CONTINUS
		lireOptions();
	}

	
	/**
	 * Lit le fichier options.dat
	 */
	public void lireOptions()
	{
		Properties lecteur = new Properties();

		FileInputStream fichier;
		
		try
		{
			fichier = new FileInputStream("Data/options.sb");
			lecteur.load(fichier);
			fichier.close();
			
			nombreContinues 	= Integer.parseInt( lecteur.getProperty("nombreContinues") );		
			isFullScreen 		= Integer.parseInt( lecteur.getProperty("fullScreen") );	
			int width			= Integer.parseInt( lecteur.getProperty("resolutionWitdh") );	
			int height			= Integer.parseInt( lecteur.getProperty("resolutionHeight") );			
			res 				= resolution.indexOf(width+" x "+height);
		}
		catch( Exception e)
		{
			nombreContinues = 3;
		}
	}
	
	
	/**
	 * Ecrit dans le fichier options.dat
	 */
	public void ecrireOptions()
	{
		Properties lecteur = new Properties();
		FileInputStream  fichier;
		FileOutputStream fichier2;
		try
		{
			fichier = new FileInputStream("Data/options.sb");
			lecteur.load(fichier);
			fichier.close();
			
			String [] resTemp = resolution.get(res).split(" x ");
			
			lecteur.setProperty("nombreContinues"	,Integer.toString( nombreContinues 	) );	
			lecteur.setProperty("fullScreen"		,Integer.toString( isFullScreen 	) );	
			lecteur.setProperty("resolutionWitdh"	,resTemp[0] 						);	
			lecteur.setProperty("resolutionHeight"	,resTemp[1] 						);	
					
			fichier2 = new FileOutputStream("Data/options.sb");
			lecteur.store( fichier2 , null);
			fichier2.close();
			
		}
		catch( Exception e){}
	}	
	
	/**
	 * Refresh
	 */
	public void raffraichir(long temps) 
	{
		super.raffraichir( temps );
		
		// APPUI OK SUR COINS
		if( clavier.estEntrer() && choix == 0)
		{
			if( nombreContinues < 29 )
				nombreContinues++;
			
			clavier.validerEntrer();
		}			
		
		boucle = System.currentTimeMillis();
		
		// affichage dans la fentre		

		// dplacement dans le menu
		if ( boucle - dernierDeplacement > 200 ) 
		{
			// Si haut
			if (clavier.estGauche()) 
			{
				//APPUI GAUCHE SUR COINS
				if( choix == 0 )
				{
					if( nombreContinues > 1 )
						nombreContinues--;
				}
				else if( choix == 1 )
				{
					res--;
					
					if( res < 0 )
						res = resolution.size() - 1;
				}
				else if( choix == 2 )
				{
						isFullScreen = 1 - isFullScreen;
				}
				dernierDeplacement = boucle;
			}
			// Si droite
			else if (clavier.estDroite()) 
			{
				if( choix == 0 )
				{	
					if( nombreContinues < 29 )
						nombreContinues++;
					
					dernierDeplacement = boucle;
				}
				else if( choix == 1 )
				{
					res++;
					
					if( res >= resolution.size() )
						res = 0;
				}				
				else if( choix == 2 )
				{
						isFullScreen = 1 - isFullScreen;
				}
				
				dernierDeplacement = boucle;
			}	
		}
	}
	
	/**
	 * Dessine le menu
	 * @param graphics2D flux
	 */
	public void dessiner( Graphics2D graphics2D )
	{
		super.dessiner(graphics2D);
	
		graphics2D.setColor( Color.black );
		graphics2D.setFont( new Font( Font.MONOSPACED, Font.BOLD, 18 ) );
		graphics2D.drawString( Integer.toString( nombreContinues ), 760, 183);
		
		if( choix == 1 )
		{
			graphics2D.setColor( Color.red );
			graphics2D.drawString( resolution.get(res), 785, 218);	
			graphics2D.setColor( Color.black );			
		}
		else
		{
			graphics2D.drawString( resolution.get(res), 785, 218);			
		}
		
		if( isFullScreen == 1 )
			graphics2D.drawString( "ON", 755, 253);
		else
			graphics2D.drawString( "OFF", 750, 253);
	}
	
	
	public boolean menuClavier()
	{
		// SI on a effectivement appuy
		if( clavier.estEntrer() && choix == 3 )
		{
			ecrireOptions();
			return true;
		}

		return false;
	}	
	
	public boolean menuPrincipal()
	{
		// SI on a effectivement appuy
		if( clavier.estEntrer() && choix == 4 || clavier.estEchappe() )
		{
			ecrireOptions();
			return true;
		}

		return false;
	}

}
