package menus;

import java.awt.Graphics2D;
import java.awt.Toolkit;

import javax.swing.ImageIcon;

import controles.ImageManager;

public class MenuPause extends Menu
{
	
	/**
	 * Construction d'un MenuPause
	 */
	public MenuPause()
	{
		menu 		= new ImageIcon [2];
		menuChoix 	= new ImageIcon [2];
			
		menu[0] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/continuer0.png"));
		menu[1] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/quitterJeu0.png"));
		
		menuChoix[0] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/continuer1.png"));
		menuChoix[1] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/quitterJeu1.png"));
	}
	
	
	/**
	 * Quitter le menu pour continuer le jeu
	 * @return vrai si dois continuer le jeu
	 */
	public boolean continuer()
	{
		return choix == 0 && clavier.estEntrer() || clavier.estEchappe();
	}
	
	
	/**
	 * Quitter le jeu pour retourner au menu principal
	 * @return vrai si dois retourner au menu principal
	 */
	public boolean retourAuMenu()
	{
		return choix == 1 && clavier.estEntrer();
	}
	
	
	/**
	 * Dessine le menu
	 * @param graphics2D buffer Image
	 */
	public void dessiner(Graphics2D graphics2D) 
	{
		// FOND
		graphics2D.drawImage( ImageManager.getImagemanager().getImageInfos(3).getImage(), 362, 284, null );
		
		// MENU
		for (int i = 0 ; i < menu.length ; i++) 
			if (i == choix) 
				graphics2D.drawImage(menuChoix[i].getImage(), 420, 350+i*35, null);
			else 
				graphics2D.drawImage(menu[i].getImage()		, 420, 350+i*35, null);
	}	

}
