package menus;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Toolkit;
import java.io.FileInputStream;
import java.util.Properties;
import javax.swing.ImageIcon;

/**
 * 
 * @author Simon Mahieux et Jerome Baudoux
 *
 */
public class MenuScore extends Menu
{
	private static final long serialVersionUID = 1L;
	private String[] score;
	private String[] nomsScore;

	/**
	 * Cree un MenuScore
	 */
	public MenuScore()
	{
		menu 			= null;
		menuChoix 		= new ImageIcon[1];
		menuChoix[0] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/retour1.png"));
		score			= new String[5];
		nomsScore		= new String[5];
		
		lireScores();
		
		typeDeMenu 		= "MenuScore";
		fond 			= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/scores.png"));
	}
	
	/**
	 * Lis les scores
	 */
	public void lireScores()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		
		try
		{
			fichier = new FileInputStream("Data/scores.sb");
			lecteur.load(fichier);
			fichier.close();

			for( int i=0;i<score.length;i++)
				score[i] =  lecteur.getProperty("score"+(i+1));
			
			for( int i=0;i<score.length;i++)
				nomsScore[i] =  lecteur.getProperty("nick"+(i+1));
		}
		catch( Exception e)
		{
			for( int i=0;i<score.length;i++)
			{
				score[i] 		= "0";
				nomsScore[i] 	= "AAA";
			}
		}
	}	
	
	/**
	 * Gere les raffraichissement
	 * @param t temps
	 */
	public void raffraichir( long temps ) {}
	
	/**
	 * Dessine le Menu
	 */
	public void dessiner(Graphics2D graphics2D) 
	{
		// FOND
		graphics2D.drawImage( fond.getImage(),0,0, null );
		
		// RETOUR
		graphics2D.drawImage( menuChoix[0].getImage(), 760, 300, null );
		
		// POSITION
		graphics2D.setFont(new Font(Font.MONOSPACED, Font.BOLD, 20));		
		graphics2D.setColor(Color.black);	
		for(int i=0;i<score.length;i++)
			graphics2D.drawString((i+1)+".", 760, 185+i*25);

		// SCORES	
		graphics2D.setColor(Color.BLACK);			
		for(int i=0;i<score.length;i++)
			graphics2D.drawString( nomsScore[i]+": ", 785, 185+i*25 );
	
		for(int i=0;i<score.length;i++)
			graphics2D.drawString( score[i], 840, 185+i*25 );
	}	
	
	/**
	 * Retour au menu principal
	 * @return
	 */
	public boolean menuPrincipal()
	{
		return clavier.estEntrer() && choix == 0 || clavier.estEchappe();
	}
}
