package son;

import java.io.File;

/**
 * SON A MULTI CANNAUX
 * @author Simon Mahieux et Jerome Baudoux
 *
 */
public class MultiSon
{
	Son [] sons;
	
	/**
	 * CONSTRUIT UN SON MULT CANNAUX
	 * @param fichier fichier
	 * @param nb nombre de cannaux
	 * @throws Exception exceptions
	 */
	public MultiSon( File fichier, int nb )throws Exception
	{
		sons = new Son[nb];
		
		for( int i=0;i<sons.length;i++ )
			sons[i] = new Son(fichier);
	}
	
	/**
	 * JOUE LE SON SI UN CANNAL EST DISPONNIBLE
	 */
	public void jouer()
	{
	   boolean ok = false;
	   
	   for( int i=0; i< sons.length && !ok; i++)
		   if(  ! sons[i].estEntrainDeJouer() )
		   {
			   sons[i].jouer();  
			   ok = true; 
		   }
	}
	
	
	/**
	 * STOP TOUS LES CANNAUX
	 */
	public void stop()
	{
	   for( int i=0; i< sons.length; i++)
			   sons[i].stop();  
	}
	
	
	/**
	 * MET TOUS LES CANNAUX EN PAUSE
	 */
	public void pause()
	{
	   for( int i=0; i< sons.length; i++)
			   sons[i].pause();  
	}
	
	
	/**
	 * REPRENDS TOUS LES CANNAUX
	 */
	public void reprise()
	{
	   for( int i=0; i< sons.length; i++)
			   sons[i].reprise();  
	}	
}
